
var sleuth_dirname, sleuth_command_line, sleuth_language, ko;

const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

// Arguments: ko, testPlanPrefs, obj{value:true/false, depending on how they leave}

const KO_ARG = 0;
const TEST_PLAN_NAME_ARG = 1;
const TEST_PLAN_ARG = 2;
const OBJ_RESULT_ARG = 3;

var sleuthEditLog;
function onLoad() {
    ko = window.arguments[KO_ARG];
    sleuthEditLog = ko.logging.getLogger('sleuth.editTestPlan');
    // sleuthEditLog.setLevel(ko.logging.LOG_DEBUG);
    var testPlanPref = window.arguments[TEST_PLAN_ARG];
    sleuth_dirname = document.getElementById('sleuth_dirname');
    sleuth_dirname.value = ko.sleuth.manager.dirFromPrefs(testPlanPref);
        
    sleuth_command_line = document.getElementById('sleuth_command_line');
    sleuth_command_line.value = testPlanPref.getStringPref('command_line');
    
    sleuth_language = document.getElementById('sleuth_language');
    var harness_indices = {};
    //XXX Add another out-object called defaultLangToHarness that
    // returns the default harness name for each language.
    ko.sleuth.manager.initHarnessPopupMenu(sleuth_language, harness_indices);
    var testPlanLanguage = testPlanPref.getStringPref("language");
    if (testPlanLanguage in harness_indices) {
        sleuth_language.setAttribute("label", testPlanLanguage);
    } else {
        // Figure out the default language (harness)
        var harness_info_from_language = {};
        ko.sleuth.manager.getLangInfoFromHarnessIndices(harness_indices, harness_info_from_language);
        if (testPlanLanguage in harness_info_from_language) {
            sleuth_language.setAttribute("label",
                    harness_info_from_language[testPlanLanguage].harnessName);
        } else {
            sleuthEditLog.info("Couldn't find a harness for 4.3 language "
                                + testPlanLanguage
                                + "\n");
            var label = null;
            for (var lang in harness_info_from_language) {
                label = harness_info_from_language[lang].harnessName;
                break;
            }
            if (!label) {
                for (var h in harness_indices) {
                    label = harness_indices[h];
                    break;
                }
            }
            if (label) {
                sleuth_language.setAttribute("label", label);
            } else {
                sleuthEditLog.info("****** Total failure to find a testPlan for language "
                     + testPlanLanguage
                     + "\n");
            }
        }
    }
    var currentTestPlanName_textbox = document.getElementById("sleuth_name");
    currentTestPlanName_textbox.value = window.arguments[TEST_PLAN_NAME_ARG];
    currentTestPlanName_textbox.setAttribute("readonly", true);
}

function editTestPlan_Accept() {
    var testPlanPref = window.arguments[TEST_PLAN_ARG];
    ko.sleuth.manager.setPrefToDir(testPlanPref, sleuth_dirname.value);
    testPlanPref.setStringPref('command_line', sleuth_command_line.value);
    testPlanPref.setStringPref("language",
                               sleuth_language.getAttribute("label"));
    window.arguments[OBJ_RESULT_ARG].value = true;
}

function editTestPlan_Cancel() {
    window.arguments[OBJ_RESULT_ARG].value = false;
}

function doBrowseForDir() {
    var dir = ko.filepicker.getFolder(sleuth_dirname.value);
    if (dir) sleuth_dirname.value = dir;
};

